'=========================================================================================
'Author: Thomas Cole
'Date Created:  01/02/2007
'Name:  master.vbs
'Revision 0
'Methodology: Set return codes used by Tivoli Package distribution.               		       
'Purpose:	Master VB script to determine file version, location, regkeys, services, 
'		and processes. Sets return codes based upon info retrieved and passes the 
'		codes to the Tivoli Packages at distribution. Wherever executed, the 
'		script will pass or fail the Tivoli Package as determined by the return codes. 
'=========================================================================================
'Edits: 05/22/2007 Edited by TC: moved the execution of the DelMasterTxt subroutine to 
'		Main to ensure operation with W2K systems. Script was not deleting
'		the PAXMaster text file on W2K systems. 	
'	02/17/2009 Changed location of the PaxMaster.txt file to reflect changes to the package 
'		template.  New location is: 
'		"C:\Program Files\UPSAPPS\LVLDM\Tivoli\dmpackage\files\paxmaster.txt"
'=========================================================================================
'Instances & Settings:

	Err.Clear
	On Error Resume Next
	Const wbemFlagReturnImmediately = &h10
	Const wbemFlagForwardOnly = &h20
	Const ForAppending = 8
'=========================================================================================	
'Declare variables 	
'Variables================================================================================
	VARdebug="off"
	cName=oNetwork.ComputerName
	strComputer = "."
	cDate= Date & " " & Time
	Status = "Good"
	rCode=0
	Dim FileName, FilePax, FileExt, FileVer, Task, Value, FileDir, RegKey, MyService, ProName, SourceFiles, LogDir
	
'=========================================================================================
'Create a multidimensional array for variables read from a text file created by the Tivoli 
'Package
'=========================================================================================
Dim fValues(10,2), a

 SourceFiles = WScript.Arguments(0)

Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objFile = objFSO.OpenTextFile(SourceFiles & "\PAXMaster.txt", 1)
a=0

Do Until objFile.AtEndOfStream
    strLine = objFile.ReadLine
	vparts = split(strLine,"=")
	fValues(a,0)=vparts(0)
	fValues(a,1)=vparts(1)
	a=a+1
Loop

	 FileName=fValues(0,1)
	 FilePax=fValues(1,1)
	 FileVer=fValues(2,1)
	 Task=fValues(3,1)
	 Value=fValues(4,1)
	 FileDir=fValues(5,1)
	 RegKey=fValues(6,1)
	 SingFile=fValues(7,1)
	 KeyName=fValues(8,1)
	 MyService=fValues(9,1)
	 ProName=fValues(10,1)

'for a=0 to 9
'	wscript.echo fValues(a,0) & "=" & fValues(a,1)
'next
'=========================================================================================
'Start Log File
'=========================================================================================

  LogDir = Wscript.Arguments(1)
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Set objFile = objFSO.OpenTextFile(LogDir & "\PEST.txt", ForAppending, True)
	objFile.WriteLine FilePax & " " & "PEST has started - " & Date & " " & Time
	
'=========================================================================================
'Execute the What2Do module, then delete the variable text file created by the Tivoli
'Package for subsequent executions. Exit with a return code set by each module in What2Do
'Main=====================================================================================		
	What2Do()
	objFile.WriteLine FilePax & " " & "PEST has ended - " & Date & " " & Time
	objFile.WriteLine "******************************************************************"
	DelMasterTxt()
	Wscript.Quit(rCode)
	
'Functions & Procedures
'Task====================================================================================
'Calls sub routines for the What2Do function based upon user need.
'========================================================================================
Function What2Do()
	If Task = "Nothing" Then
		Status = "Good"
'		ReturnCode()
	End If
	If Task = "Conflict" Then 
		call FindFile()
		call FindSingFileVer()
		call FindRegKey()
		call FindService()
		call FindProcess()
'		ReturnCode()
	End If
	If Task = "Dependency" Then
		call FindFile()
		call FindSingFileVer()
		call FindRegKey()
		call FindService()
		call FindProcess()
'		ReturnCode()
	End If
End Function	

'Find File===============================================================================
'Finds file and sets return code.
'========================================================================================
Sub FindFile()
	Dim objFSO
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	If objFSO.FileExists(FileName) Then
		If FileName <> "Nothing" Then
			Select Case Task
				Case "Conflict"
					Status = "Conflicting File Found"
					rCode=1	
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & FileName 	
			End Select
		End If
	End If
	If Not objFSO.FileExists(FileName) Then
		If FileName <> "Nothing" Then
			Select Case Task
				Case "Dependency" 
					Status = "Dependant File Missing"
					rCode=2	
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & FileName
			End Select
		End If
	End If		
End Sub
'FindSingFileVer==========================================================================
'Looks for single file version and sets return code.
'=========================================================================================
Sub FindSingFileVer() 
	Dim objFSO
	Dim Output
	Set objFSO = CreateObject("Scripting.FileSystemObject")
		If FileVer <> "Nothing" Then
		OutPut=objFSO.GetFileVersion(SingFile)
			If OutPut = FileVer Then 
				Select Case Task 
					Case "Conflict" 
					Status = "Conflicting File Version"
					rCode=3
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & SingFile & " " & FileVer
				End Select	
			End If
			If OutPut <> FileVer Then
				Select Case Task
					Case "Dependency" 
					Status = "Dependant File Version Missing" 
					rCode=4
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & SingFile & " " & FileVer
				End Select 	
			End If	
		End If		
End Sub
'FindRegKey===============================================================================
'Looks for specified registry key and sets return code.
'=========================================================================================
Sub FindRegKey()
	Dim objRegistry	
	Dim strComputer
	Const HKEY_LOCAL_MACHINE = &H80000002
	Const HKEY_CURRENT_USER = &H80000001

	strComputer = "."
	Set objRegistry = GetObject("winmgmts:\\" & strComputer & "\root\default:StdRegProv")
	strKeyPath = RegKey
	strValueName = KeyName
	strValue = Value
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE,RegKey,KeyName,Value
	
	If strKeyPath <> "Nothing" Then
		Select Case Task
			Case "Conflict"
				If strValue = Value Then
					Status = "Conflicting Reg Key Found"
					rCode=5
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & RegKey & KeyName & Value
				End If
			Case "Dependency"
				If strValue = Value Then 
					rCode=0
					Status = "Good"
				Else rCode=6
					Status = "Dependent Reg Key Missing"
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & RegKey & KeyName & Value
				End If
		End Select
	End If
End Sub
'Service==================================================================================
'Checks for conflicting or dependant service and sets return code.
'=========================================================================================
Sub FindService()
strComputer = "."
count=0

Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

Set colRunningServices = objWMIService.ExecQuery("Select * from Win32_Service")

For Each objService in colRunningServices 
 
	If MyService <> "Nothing" Then
		Select Case Task
			Case "Conflict"
					If Ucase(objService.DisplayName) = Ucase(MyService) And objService.State = "Running" Then
					Status = "Conflicting Service Is Running"
					rCode=7
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & MyService
				End If	
				If Ucase(objService.DisplayName) = Ucase(MyService) And objService.State <> "Running" Then
					Status = "Conflicting Service Exist but not Running"
					rCode=8
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & MyService
				End If	
			Case "Dependency" 
				If Ucase(objService.DisplayName) = Ucase(MyService) Then
					count=count+1
				End If	
		End Select		
	End If	
Next
If MyService <> "Nothing" Then
	If Task="Dependency" Then
		If count=0 Then 	
			rCode=9 
			Status = "Dependent Service is Missing"
			objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & MyService
		Else
		End If	
	End If					
End If
End Sub
'Process==================================================================================
'Checks for conflicting or dependent processes and sets the return code.
'=========================================================================================
Sub FindProcess()
strComputer = "."
count=0

Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
Set colProcesses = objWMIService.ExecQuery _
    ("Select * from Win32_Process")

For Each objProcess in colProcesses
	If ProName <> "Nothing" Then 
		Select Case Task
			Case "Conflict"
				If Ucase(objProcess.Name) = Ucase(ProName) Then
					Status = "Conflicting Process Found"
					rCode=10
					objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & ProName
				End If
			Case "Dependency"
				If Ucase(objProcess.Name) = Ucase(ProName) Then
					count=count+1
				End If
		End Select
	End If	
Next
If ProName <> "Nothing" Then
	If Task="Dependency" Then
		If count=0 Then 	
			rCode=11 
			Status = "Dependent Process is Missing"
			objFile.WriteLine "Return Code" & " " & rCode & " " & Status & " " & ProName
		Else 
		End If	
	End If					
End If
End Sub
'DelMasterTxt=============================================================================
'Deletes the PAXMaster.txt file created by the Tivoli Package.
'=========================================================================================
Sub DelMasterTxt()
	strComputer = "."

	Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")

	Set colFileList = objWMIService.ExecQuery _
		("ASSOCIATORS OF {Win32_Directory.Name='D:\UPSDATA\Tivoli\LVLDM\dmpackage\files'} Where " _
			& "ResultClass = CIM_DataFile")

	For Each objFile In colFileList
		If InStr(objFile.FileName, "PAXMaster") Then
			objFile.Delete
		End If
	Next
End Sub	
'ReturnCode===============================================================================
'Evaluates return codes and sets codes in Tivoli Package. This module is not operational
'but the code remains if needed later. 
'=========================================================================================
'Function ReturnCode()
	
	If Status = "Good" Then
		rCode=0	
	End If	
	If Status = "Conflicting File Found" Then
		rCode=1
	End If	
	If Status = "Dependant File Missing" Then 
		rCode=2
	End If	
	If Status = "Conflicting File Version" Then 
		rCode=3
	End If	
	If Status = "Dependant File Version Missing" Then 
		rCode=4
	End If	
	If Status = "Conflicting RegKey Found" Then 
		rCode=5
	End If	
	If Status = "Dependant RegKey Missing" Then 
		rCode=6
	End If	
	If Status = "Conflicting Service is Running" Then 
		rCode=7
	End If	
	If Status = "Conflicting Service Exist but not Running" Then 
		rCode=8
	End If
	If Status = "Dependent Service Missing" Then 
		rCode=9
	End If
	If Status = "Conflicting Process Found" Then 
		rCode=10
	End If
	If Status = "Dependent Process Missing" Then 
		rCode=11
	End If
'End Function	
'=========================================================================================		